package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("NetworkDefinition")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class NetworkDefinition implements Marshallable {
	private String networkName;
	private long version;
	private PartitionInfo[] partitions;
	private ValidatorInfo[] validators;

    //
	public String getNetworkName() {
	    return networkName;
	}
	public void setNetworkName(final String value) {
	    this.networkName = value;
	}

	public NetworkDefinition networkName(final String value) {
	    setNetworkName(value);
	    return this;
	}
	public long getVersion() {
	    return version;
	}
	public void setVersion(final long value) {
	    this.version = value;
	}

	public NetworkDefinition version(final long value) {
	    setVersion(value);
	    return this;
	}
	public PartitionInfo[] getPartitions() {
	    return partitions;
	}
	public void setPartitions(final PartitionInfo[] value) {
	    this.partitions = value;
	}

	public NetworkDefinition partitions(final PartitionInfo[] value) {
	    setPartitions(value);
	    return this;
	}
	public ValidatorInfo[] getValidators() {
	    return validators;
	}
	public void setValidators(final ValidatorInfo[] value) {
	    this.validators = value;
	}

	public NetworkDefinition validators(final ValidatorInfo[] value) {
	    setValidators(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.networkName == null || this.networkName.length() == 0)) {
            marshaller.writeString(1, this.networkName);
        }
        if (!(this.version == 0)) {
            marshaller.writeUint(2, this.version);
        }
        if (!(this.partitions == null)) {
            marshaller.writeValue(3, partitions);
        }
        if (!(this.validators == null)) {
            marshaller.writeValue(4, validators);
        }
        return marshaller.array();
    }
}
